=== debian/changelog ===
apt-cacher-ng (3-5) unstable; urgency=low

  * Moving RequiresMountsFor to Unit section (closes: #859520)

 -- Eduard Bloch <blade@debian.org>  Thu, 27 Apr 2017 20:12:02 +0200

apt-cacher-ng (3-4) unstable; urgency=medium

  * Made cron.daily tolerant to removal of config files (closes: #858952)

 -- Eduard Bloch <blade@debian.org>  Sun, 02 Apr 2017 10:05:38 +0200

apt-cacher-ng (3-3) unstable; urgency=medium

  * Updated debian/copyright to match the upstream version (now really)

 -- Eduard Bloch <blade@debian.org>  Tue, 28 Mar 2017 21:01:49 +0200

apt-cacher-ng (3-2) unstable; urgency=medium

  * Updated debian/copyright to match the upstream version

 -- Eduard Bloch <blade@debian.org>  Tue, 28 Mar 2017 20:09:54 +0200

apt-cacher-ng (3-1) unstable; urgency=medium

  * New upstream version
    + GCC7 compilation fixes (closes: #853315)
    + fixes hidden space allocation issue (closes: #856635)
    + smarter manual index deletion wizard which covers related files too
      (probably closes: #789706)
  * Spanish translation update (by Matías A. Bellone, closes: #853105)
  * Instructions on how to work around cron job execution and "special needs"
    of some users to disable the admin page (closes: #855996)
  * Added RequiresMountsFor to systemd service description (closes: #855618,
    only in Debian patch for now)

 -- Eduard Bloch <blade@debian.org>  Wed, 22 Mar 2017 20:30:21 +0100
