## apt-cacher-ng 3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -106,7 +106,7 @@
         _append(ACNG_CXXFLAGS -fvisibility-inlines-hidden)
 endif()
 
-foreach(linkarg -Wl,--as-needed -Wl,-O1 -Wl,--discard-all -Wl,--no-undefined -Wl,--build-id=sha1 -Wl,-fuse-ld=gold -Wl,--threads)
+foreach(linkarg -Wl,--as-needed -latomic -Wl,-O1 -Wl,--discard-all -Wl,--no-undefined -Wl,--build-id=sha1 -Wl,-fuse-ld=gold -Wl,--threads)
 	STRING(REGEX REPLACE "=|-|," "" optname "${linkarg}")
 	set(CMAKE_REQUIRED_FLAGS "${linkarg}")
 	CHECK_CXX_COMPILER_FLAG("" "LD_${optname}")
@@ -189,12 +189,6 @@
    LIST(APPEND BaseNetworkLibs socket nsl)
 endif(HAVE_SOCKETLIB)
 
-FIND_LIBRARY(HAVE_ATOMICLIB atomic) # needed for global atomic vars on some 32bit architectures
-if(HAVE_ATOMICLIB)
-        MESSAGE("-- Found libatomic development files, will link libatomic")
-        LIST(APPEND BaseNetworkLibs atomic)
-endif()
-
 SET(CMAKE_REQUIRED_LIBRARIES wrap ${BaseNetworkLibs})
 FILE(READ test/build/HAVE_LIBWRAP.cc TESTSRC)
 CHECK_CXX_SOURCE_COMPILES("${TESTSRC}" HAVE_LIBWRAP)
@@ -350,3 +344,7 @@
 
 # -DEXTRA_LIBS_INETD=-lsupc++
 # funny hack, link with gcc and avoid libstdc++/libm (since STL is not used
+# there). However, it needs to be tested - the alternative linking makes
+# the binary ~40kb larger, might include higher relocation costs and bigger
+# chunks of unique memory while libstdc++ needs to be loaded anyway for the
+# server process.
