=== debian/changelog ===
apt-cacher-ng (3.1-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:48:32 +0000

apt-cacher-ng (3.1-1) unstable; urgency=low

  * New upstream version
    + removed doc references to distkill.pl (closes: #877703, LP: #1635029)
    + includes fix for rare expiration failure on missing index files
      (closes: #872830)
    + fixes credential printing in logs (closes: #877135)
    + hardens default pass-through mask for bugs.debian.org (closes: #874349)
  * Portuguese translation update (by Traduz, closes: #874609)
  * Policy definition and build-deps update (no related changes)

 -- Eduard Bloch <blade@debian.org>  Sun, 05 Nov 2017 20:55:20 +0100
