## apt-cacher-ng 3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -106,7 +106,7 @@
         _append(ACNG_CXXFLAGS -fvisibility-inlines-hidden)
 endif()
 
-foreach(linkarg -Wl,--as-needed -latomic -Wl,-O1 -Wl,--discard-all -Wl,--no-undefined -Wl,--build-id=sha1 -Wl,-fuse-ld=gold -Wl,--threads)
+foreach(linkarg -Wl,--as-needed -Wl,-O1 -Wl,--discard-all -Wl,--no-undefined -Wl,--build-id=sha1 -Wl,-fuse-ld=gold -Wl,--threads)
 	STRING(REGEX REPLACE "=|-|," "" optname "${linkarg}")
 	set(CMAKE_REQUIRED_FLAGS "${linkarg}")
 	CHECK_CXX_COMPILER_FLAG("" "LD_${optname}")
@@ -200,6 +200,14 @@
 ENDIF(HAVE_LIBWRAP)
 SET(CMAKE_REQUIRED_LIBRARIES "")
 
+# lib is not in the standard path so FIND_LIBRARY is not reliable
+set(CMAKE_REQUIRED_FLAGS "-latomic")
+CHECK_CXX_COMPILER_FLAG("" LD_ATOMIC)
+if(LD_ATOMIC)
+_append(BaseNetworkLibs atomic)
+endif()
+set(CMAKE_REQUIRED_FLAGS "")
+
 if(CYGWIN)
 message("!! Not using wordexp on Cygwin, not reliable")
 set(HAVE_WORDEXP off)
@@ -344,7 +352,3 @@
 
 # -DEXTRA_LIBS_INETD=-lsupc++
 # funny hack, link with gcc and avoid libstdc++/libm (since STL is not used
-# there). However, it needs to be tested - the alternative linking makes
-# the binary ~40kb larger, might include higher relocation costs and bigger
-# chunks of unique memory while libstdc++ needs to be loaded anyway for the
-# server process.
