=== debian/changelog ===
apt-cacher-ng (3.2-3~bpo9+1) stretch-backports-sloppy; urgency=medium

  * Straight rebuild for stretch-backports-sloppy

 -- Eduard Bloch <blade@debian.org>  Thu, 14 Nov 2019 16:03:33 +0100

apt-cacher-ng (3.2-3~bpo10+1) buster-backports; urgency=medium

  * Straight rebuild for buster-backports

 -- Eduard Bloch <blade@debian.org>  Thu, 14 Nov 2019 15:40:28 +0100

apt-cacher-ng (3.2-3) unstable; urgency=medium

  * Increase decompression line buffer size (closes: #942634)

 -- Eduard Bloch <blade@debian.org>  Mon, 28 Oct 2019 22:14:46 +0100

apt-cacher-ng (3.2-2) unstable; urgency=medium

  *  Fix for incorrect assumption of some existing SHA256SUMS files in Debian
     repositories which makes the expiration task fail without a proper way
     for the end user to recover from it. Now ignore a download error in this
     case (similar handling as for other guesses), assuming that permanent
     404ing for other reasons than removal of remote content can be considered
     unlikely (closes: #928957)

 -- Eduard Bloch <blade@debian.org>  Fri, 17 May 2019 22:59:21 +0200

apt-cacher-ng (3.2-1) unstable; urgency=low

  * New upstream version
    + Allow tunnel mode per default for some Debian and Ubuntu services
      closes: #906113
    + Adding remap config for security.d.o
      closes: #900325
    + Fix incorrect -C option in manpage and other minor errors
      closes: #901292, #901294, #901295
    + Remove obsolete option from config output
      closes: #859680
  * Removed the DISABLED flag from the init script (current Debian policy,
    section 9.3.3.1)
  * Raised the debconf priority to high for the question about proxy tunnel
    permissions (like HTTPS) since there is no perfect default.
    closes: #814359

 -- Eduard Bloch <blade@debian.org>  Fri, 07 Sep 2018 11:30:33 +0200
